// EulerTest.cpp : ܼ  α׷   մϴ.
//

#include "stdafx.h"
#include "Euler.h"

//int _tmain(int argv, char* argc[])
//{
//	/*
//	if (argv != 2)
//	{
//	std::cout << "File name should be written \n" << std::endl;
//	exit(0);
//	}
//	*/
//
//	FILE* p = fopen("rotate_data.txt", "rb");
//	char* temp = new char[20];
//	double* key = new double[1000];
//	memset(key, 0, sizeof(double)*1000);
//
//	char t;
//	while((t = fgetc(p)) != '[');
//
//	//	double temp2;
//	int cnt = 0;
//
//	fscanf(p, "%s", temp);
//	while(temp[0] != ']')
//	{
//		key[cnt++] = (atof(temp)*3.33);
//		fscanf(p, "%s", temp);
//	}
//	//	char t;
//	while((t = fgetc(p)) != '[');
//
//	double** keyvalue = new double*[1000];
//	for(int i = 0; i < 1000; i++)
//	{
//		keyvalue[i] = new double[4];
//		memset(keyvalue[i], 0, sizeof(double)*4);
//	}
//
//	cnt = 0;	
//	fscanf(p, "%s", temp);
//	double PI = acos((double)-1);
//	while(temp[0] != ']')
//	{
//		keyvalue[cnt][0] = atof(temp);
//		fscanf(p, "%s", temp);
//		keyvalue[cnt][1] = atof(temp);
//		fscanf(p, "%s", temp);
//		keyvalue[cnt][2] = atof(temp);
//		fscanf(p, "%s", temp);
//		keyvalue[cnt++][3] = atof(temp);//(atof(temp) * 180 / PI);
//		fscanf(p, "%s", temp);
//	}
//
//	double** values = new double*[cnt];
//
//	for(int i = 0; i < cnt; i++)
//	{		
//		values[i] = toEuler(keyvalue[i][0], keyvalue[i][1], keyvalue[i][2], keyvalue[i][3]);
//		//	std::cout << keyvalue[i][0] << '\t' <<  keyvalue[i][1] << '\t' << keyvalue[i][2] << '\t' << keyvalue[i][3] << std::endl;
//		//	std::cout << values[i][0] << '\t' <<  values[i][1] << '\t' << values[i][2] << '\t' << std::endl;
//	}
//
//	FILE* output = fopen("EulerAngle.txt", "wb");
//	fprintf(output, "cnt = %d\n\n\n", cnt);
//	for(int i = 0; i < cnt; i++)
//	{
//		fprintf(output, "%lf ", key[i]);		
//	}
//	fprintf(output, "\n\n\n");
//
//	for(int i = 0; i < cnt; i++)
//	{
//		/*
//		if (i != 0)
//		keyvalue[i][0] += keyvalue[i-1][0];
//		if (keyvalue[i][0] > 360)
//		keyvalue[i][0] -= 360;	
//		if (keyvalue[i][0] < -360)
//		keyvalue[i][0] += 360;
//		*/
//		fprintf(output, "%lf ", (values[i][0]*180)/PI);
//	}
//	fprintf(output, "\n\n\n");
//
//	for(int i = 0; i < cnt; i++)
//	{
//		/*
//		if (i != 0)
//		keyvalue[i][0] += keyvalue[i-1][0];
//		if (keyvalue[i][0] > 360)
//		keyvalue[i][0] -= 360;	
//		if (keyvalue[i][0] < -360)
//		keyvalue[i][0] += 360;
//		*/
//		fprintf(output, "%lf ", (values[i][1]*180)/PI);
//	}
//	fprintf(output, "\n\n\n");
//
//	for(int i = 0; i < cnt; i++)
//	{
//		/*
//		if (i != 0)
//		keyvalue[i][0] += keyvalue[i-1][0];
//		if (keyvalue[i][0] > 360)
//		keyvalue[i][0] -= 360;	
//		if (keyvalue[i][0] < -360)
//		keyvalue[i][0] += 360;
//		*/
//		fprintf(output, "%lf ", (values[i][2]*180)/PI);
//	}
//	fprintf(output, "\n\n\n");
//
//	//rotate(x2, y2, z2);
//
//	fclose(p);
//	fclose(output);
//	return 0;
//}
//

double *rotate(double heading, double attitude, double bank) {
	// Assuming the angles are in radians.
	double* values = new double[4];

	double c1 = cos(heading/2);

	double s1 = sin(heading/2);

	double c2 = cos(attitude/2);

	double s2 = sin(attitude/2);




	double c3 = cos(bank/2);

	double s3 = sin(bank/2);

	double c1c2 = c1*c2;

	double s1s2 = s1*s2;

	double w =c1c2*c3 - s1s2*s3;

	double x =c1c2*s3 + s1s2*c3;

	double y =s1*c2*c3 + c1*s2*s3;

	double z =c1*s2*c3 - s1*c2*s3;




	double angle = 2 * acos(w);

	double norm = x*x+y*y+z*z;

	if (norm < 0.001) { // when all euler angles are zero angle =0 so

		// we can set axis to anything to avoid divide by zero

		x=1;

		y=z=0;

	} else {




		norm = sqrt(norm);

		x /= norm;

		y /= norm;

		z /= norm;

	}
	//std::cout<<angle<< '\t' << x<< '\t' << y  << '\t' << z << std::endl;

	values[0] = x;
	values[1] = y;
	values[2] = z;
	values[3] = angle;

	return values;
}

double* toEuler(double x,double y,double z,double angle) {

	double s=sin(angle);

	double c=cos(angle);

	double t=1-c;

	//  if axis is not already normalised then uncomment this

	// double magnitude = Math.sqrt(x*x + y*y + z*z);




	// if (magnitude==0) throw error;

	// x /= magnitude;

	// y /= magnitude;

	// z /= magnitude;
	double heading, attitude, bank;
	double* values = new double[3];
	double PI = acos((double)-1);

	if ((x*y*t + z*s) > 0.998) { // north pole singularity detected

		heading = 2*atan2(x*sin(angle/2),cos(angle/2));




		attitude = PI/2;

		bank = 0;

		values[0] = bank;
		values[1] = heading;
		values[2] = attitude;
		return values;

	}

	if ((x*y*t + z*s) < -0.998) { // south pole singularity detected

		heading = -2*atan2(x*sin(angle/2),cos(angle/2));

		attitude = -PI/2;




		bank = 0;

		values[0] = bank;
		values[1] = heading;
		values[2] = attitude;
		return values;

	}

	heading = atan2(y * s- x * z * t , 1 - (y*y+ z*z ) * t);

	attitude = asin(x * y * t + z * s) ;

	bank = atan2(x * s - y * z * t , 1 - (x*x + z*z) * t);

	values[0] = bank;
	values[1] = heading;
	values[2] = attitude;
	return values;

}
