#ifndef _CREATEOD_H_
#define _CREATEOD_H_

extern "C" 
	{
		#include "gpac/nodes_mpeg4.h"
		#include "gpac/list.h"
		#include "gpac/internal/bifs_dev.h"
		#include "gpac/internal/scenegraph_dev.h"
		#include "gpac/internal/isomedia_dev.h"
		#include "gpac/mpeg4_odf.h"
	}
//variables
typedef struct tagM4OD
{
	char *mp4FileName;
	char *outAU	;			
	u32  au_length	;		
	M4Err e	;				
	int NumberODs	;		
	LPODCODEC encoder;		
	ODCommand *command;
	ObjectDescriptorUpdate* odUpdate ;
	ObjectDescriptor* od;				
	ESDescriptor* pOdESD;				
	DecoderConfigDescriptor* pDecCon;	
	SLConfigDescriptor* pSlcCon	;		
	
}ODData;

typedef struct tagM4MUX
{
	M4Movie *mm;// = NULL;
	int track_number;//  =  0;
	ODData*;// = NewODData();

}MUXData;


//functions
ODData *NewODData();
int InitOD();
int AddODSample(int ODID, int ESID, const char* streamFormat, int streamType, int objectTypeIndication, int bufferSizeDB);
int CreateODBuffer();


#endif //_CREATEOD_H_