#pragma once

extern "C"
{
#include "gpac/isomedia.h"
#include "gpac/internal/isomedia_dev.h"
#include "gpac/internal/bifs_dev.h"
	#include "gpac/internal/odf_dev.h"
//extern "C" M4Err AddMovieIOD(MovieAtom *moov, u8 isIOD);
//extern "C" M4Err M4_AddTrackToRootOD(M4File *the_file, u32 trackNumber);
}

class MakeOD
{
public:
	MakeOD(void);
public:
	~MakeOD(void);

private:
	int InitVars();

public:
	//variables
	//char *mp4FileName;
	char *outAU	;			
	u32  au_length	;		
	GF_Err e;				
	int NumberODs;		
	//GF_BifsEncoder* encoder;
	GF_ODCodec *encoder;
	GF_ODCom *command;
	GF_ODUpdate* odUpdate ;
	GF_ObjectDescriptor* od;				
	GF_ESD* pOdESD;				
	GF_DecoderConfig* pDecCon;	
	GF_SLConfig* pSlcCon;	
	
	
	//functions
	
	int InitOD();
	int AddODSample(int ODID, int ESID, const char* streamFormat, int streamType, int objectTypeIndication, int bufferSizeDB);
	int CreateODBuffer();
	int DeleteODData();

};