#ifndef _VBTOMP4LIB_H_
#define _VBTOMP4LIB_H_



// initializes the library, call this function first
int VBtoMP4Lib_Init();
// Free the memory for data in the library, call it at the end
int VBtoMP4Lib_Free();
// Set the Vertex Buffer and Appearance Buffer
int VBtoMP4Lib_SetVB( unsigned char* &buff, int &size,  unsigned char* &Apbuff, int &Apsize);
// Set the Texture Buffer
int VBtoMP4Lib_SetTB( unsigned char* &buff, int &size, int id, const char* daeId);
// Set the Animation Buffer
int VBtoMP4Lib_SetAB( unsigned char* &buff, int &size, int id, bool isMP4Stream = false);
// Create mp4
int VBtoMP4Lib_CreateMP4(const char* file_name);
//Set 3DMC Bufffer
int VBtoMP4Lib_Set3DMC( unsigned char* &buff, int &size, int id, const char* daeId);
//Set RAR Bufffer
int VBtoMP4Lib_SetRAR( unsigned char* &buff, int &size);
//Set RAR Bufffer
int VBtoMP4Lib_SetRARinMETA( unsigned char* &buff, int &size);
//Get information for file tracks size
int VBtoMP4Lib_GetTrackSize(int &ODSize, int &BIFSSize,int &DMCSize, int &IMGSize, int &BBASize);

//for exporter
int VBtoMP4Lib_AddBifs( void* INscene,unsigned char* &buff, int &size );
//int VBtoMP4Lib_SetBIFS(void* scene);
int VBtoMP4Lib_SetBBA(unsigned char* &buff, int &size, int id, bool isEncoded );
int VBtoMP4Lib_ExportMP4(const char* file_name);

#endif //_VBTOMP4LIB_H_