/*!
 ************************************************************************
 *  \file
 *     gEdge.cpp
 *  \brief
 *     gEdge class.
 *  \author
 *     Copyright (C) 2007  ARTEMIS Department INT/GET, Paris, France.
 *
 *     Khaled MAMOU               <khaled.mamou@int-evry.fr>
 *
 *	   Institut National des Telecommunications		tel.: +33 (0)1 60 76 40 94
 *     9, Rue Charles Fourier,						fax.: +33 (0)1 60 76 43 81
 *     91011 Evry Cedex France
 *
 ************************************************************************
 */

#include "gEdge.h"
#include "Console.h"

extern CConsole logger;

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

gEdge::gEdge()
{
	name_ = -1;
	v1_ = -1;
	v2_ = -1;
	tag_ = -1;
	error_ = 0.0;
}

gEdge::~gEdge()
{

}

void gEdge::Info()
{
	logger.write_2_log("%i (%i, %i) %i", name_, v1_, v2_, tag_);
}
