/*!
 ************************************************************************
 *  \file
 *     gVertex.h
 *  \brief
 *     gVertex class.
 *  \author
 *     Copyright (C) 2007  ARTEMIS Department INT/GET, Paris, France.
 *
 *     Khaled MAMOU               <khaled.mamou@int-evry.fr>
 *
 *	   Institut National des Telecommunications		tel.: +33 (0)1 60 76 40 94
 *     9, Rue Charles Fourier,						fax.: +33 (0)1 60 76 43 81
 *     91011 Evry Cedex France
 *
 ************************************************************************
 */
#pragma once
#include <vector>
class gVertex  
{
public:
	int name_;
	std::vector<int> edges_;
	std::vector<int> ancestors_;
	int cc_;

	double error_;

	int AddEdge(int name);
	int DelEdge(int name);
	

	void Info();

	gVertex();
	virtual ~gVertex();

};