/******************************************************************************\
* Includes
\******************************************************************************/
#include "MPG_IfsQ_C_Ifs.h"


/******************************************************************************\
 MPG_IfsQ_C_Ifs.cpp.cpp: implementation of the MPG_IfsQ_C_Ifs class:
\******************************************************************************/


/******************************************************************************\
* Class MPG_IfsQ_C_Ifs
\******************************************************************************/
MPG_IfsQ_C_Ifs::MPG_IfsQ_C_Ifs():MPG_IfsQ_C()
{
	//this->_3DMC_extension	= true;
}

MPG_IfsQ_C_Ifs::~MPG_IfsQ_C_Ifs()
{
}


void MPG_IfsQ_C_Ifs::read3DMCData( MP43DMC *dmc )
{
	
	// Load coordinates
	for( int i = 0; i < dmc->GetCoordinateCount(); i++ )
		this->_coord.push_back( dmc->GetCoordinate()[i]  );
	
	// Load normals
	for( int i = 0; i < dmc->GetNormalCount(); i++ )
		this->_normal.push_back( dmc->GetNormal()[i]  );
	
	// Load textcoords
	for( int i = 0; i < dmc->GetTextureCoordinateCount(); i++ )
		this->_texCoord.push_back( dmc->GetTextureCoordinate()[i]  );

	// Load colors
	for( int i = 0; i < dmc->GetColorCount(); i++ )
		this->_color.push_back( dmc->GetColor()[i]  );
	
	//Indexes
	
	// Load the coordinates index
	for( int i = 0; i < dmc->GetCoordinateIndexCount(); i++ )
		this->_coordIndex.push_back( dmc->GetCoordinateIndex()[i]  );

	// Load the texture coordinates index
	for( int i = 0; i < dmc->GetTextureCoordinateIndexCount(); i++ )
		this->_texCoordIndex.push_back( dmc->GetTextureCoordinateIndex()[i]  );

	// Load the normals index
	for( int i = 0; i < dmc->GetNormalIndexCount(); i++ )
		this->_normalIndex.push_back( dmc->GetNormalIndex()[i]  );
	
	// Load the colors index
	for( int i = 0; i < dmc->GetColorIndexCount(); i++ )
		this->_colorIndex.push_back( dmc->GetColorIndex()[i]  );

}



