#pragma once
#ifndef _MAKEOD_H_
#define _MAKEOD_H_


/******************************************************************************\
* Includes
\******************************************************************************/
#include "gpac/isomedia.h"
#include "gpac/internal/isomedia_dev.h"
extern "C"
{
#include "gpac/internal/bifs_dev.h"
#include "gpac/internal/odf_dev.h"
}
/******************************************************************************\
* Class MakeOD
\******************************************************************************/
class MakeOD
{
public:
	MakeOD(void);
	~MakeOD(void);

private:
	int InitVars();

public:

	//variables
	
	char *outAU	;			
	u32  au_length	;		
	GF_Err e;				
	int NumberODs;		
	
	GF_ODCodec *encoder;
	GF_ODCom *command;
	GF_ODUpdate* odUpdate ;
	GF_ObjectDescriptor* od;				
	GF_ESD* pOdESD;				
	GF_DecoderConfig* pDecCon;	
	GF_SLConfig* pSlcCon;	
	
	
	//functions
	
	int InitOD();
	int AddODSample(int ODID, int ESID, const char* streamFormat, int streamType, int objectTypeIndication, int bufferSizeDB);
	int CreateODBuffer();
	int DeleteODData();

};

#endif //_MAKEOD_H_