#pragma once

/******************************************************************************\
* Class MP4toXMTDecode
\******************************************************************************/
class MP4toXMTDecode
{
public:
	MP4toXMTDecode(void);
	~MP4toXMTDecode(void);

	//methods
	//create x3d file from mp4 file
	//mp4 file in meta data should have part of gziped x3d which is standard x3d file with empty IFS
	//also mp4 file should have tracks with 3DMC stream and/or BBA stream
	
	bool RestoreXMTFile( const char * mp4FileName, const char* x3dFileName );

private:

	//methods
	
	bool RestoreGeometry( const char * x3dFileName );
	
	bool RestoreXML(  const char * x3dFileName );
	
};
