using System;
using System.Collections.Generic;
using System.Text;

namespace MP25
{
    public class EncoderParameters
    {
        public int m_3dmc_bits_coord;
        public int m_3dmc_bits_normal;
        public int m_3dmc_bits_texcoord;
        public int m_3dmc_bits_color;
        public bool m_3dmc_order_vertex;
        public bool m_3dmc_order_face;

        public int m_famc_bits_coord;
        public int m_famc_bits_normal;
        public int m_famc_bits_texcoord;
        public int m_famc_bits_color;

        public int m_bba_qs;
        public int m_bba_p2qs;
        public int m_bba_coding;

        public int m_inter_coding;

        public EncoderParameters()
        {
            SetDefaults();
        }

        public void SetDefaults()
        {
            m_3dmc_bits_coord = 10;
            m_3dmc_bits_normal = 9;
            m_3dmc_bits_texcoord = 7;
            m_3dmc_bits_color = 10;
            m_3dmc_order_vertex = true;
            m_3dmc_order_face = true;

            m_famc_bits_coord = 16;
            m_famc_bits_normal = 13;
            m_famc_bits_texcoord = 10;
            m_famc_bits_color = 16;

            m_bba_qs = 7;
            m_bba_p2qs = 6;
            m_bba_coding = 1;

            m_inter_coding = 1;
        }
        
    }
}
