// vector.h: interface for the vector class.
//
//////////////////////////////////////////////////////////////////////

#ifndef _BIFSVECTOR_H_
#define _BIFSVECTOR_H_

#include "BBAInclude.h"

template <class T> class BIFSvector
{
public:
	BIFSvector();
	BIFSvector(BIFSvector<T>& vector);

	void push_back(T val);
	void pop_back();
	void pop_front();
	unsigned int size();	
	T& operator [](int i);	
	BIFSvector& operator=(const BIFSvector& vector);
	~BIFSvector();
	void clear();
protected:	
	
	Chain* _list;

};


#endif // !defined(_BIFSVECTOR_H_)
