#include "MapLists.h"

int lastID=0;//ANMLastID,OPCLastID=0,ANMLastID=0;

//void Initialise

/*
extern OGList=NewChain();
extern OPCList=NewChain();
extern ANMList=NewChain();
*/

typedef struct mapping_Atom_ID_nodeID
{
	unsigned int Atom_ID;
	void* NodeID;
} mapIdId;


unsigned int addMap(Chain* pChain,void* nodeId)//unsigned int nodeId)
{
	mapIdId* pMp=new mapIdId();
	pMp->Atom_ID = ++lastID;
	pMp->NodeID = nodeId;
	ChainAddEntry(pChain,pMp);
	return pMp->Atom_ID;
}

unsigned int findMap(Chain* pChain,void* nodeId)//unsigned int nodeId)
{
	unsigned int i;	
	for (i=0;i<ChainGetCount(pChain);i++)
	{
		mapIdId* pMp=(mapIdId*)ChainGetEntry(pChain,i);
		if (pMp->NodeID==nodeId)
			return pMp->Atom_ID; 
	}
	return 0;
}

void deleteMap(Chain* pChain)
{
	unsigned int i;
	for (i=0;i<ChainGetCount(pChain);i++)
	{
		mapIdId* pMp=(mapIdId*)ChainGetEntry(pChain,i);
		delete pMp;
	}
	ChainReset(pChain);
	DeleteChain(pChain);
}