

#ifndef _BBA_ENCODER_LIB_H_
#define _BBA_ENCODER_LIB_H_



#ifndef PREDICTIVE_CODING_TYPE
#define PREDICTIVE_CODING_TYPE		0 
#endif 

#ifndef DCT_CODING_TYPE
#define DCT_CODING_TYPE				1 
#endif 

//bool hasHeader	put true if textual bba has header, false if not
//int automaticIN,  put 0 to put by yourself number of p-frames, put 1 for automatic compute p - frames ( case with automaticIN=1 not tested enought )
//int p_framesIN,   put number of p frames, best tested with p_framesIN = 0
//int coding_typeIN put 0 for FRAMEBASED, 1 for DCT method
//int p2q, int gs   these are quantisation steps, values from 0 to 7 are accsepted. If crach with small values, means you should increase them
//void* bufferIN    buffer with textual BBA
//int bufferINSize  size of bufferIN
//unsigned char* &bufferOUT   return buffer with encodded BBA. YOU SHOULD ALLOCATE MEMORY for this buffer
//int &bufferOUTSize this is returned value, size of bufferOUT
//int noFrames		 number of frames you want to encode. Put 0 for all buffer
//bool saveINFile    put true if you like to dump encoded BBA in file, false if not. if yes file is saved in current directory, under name encodedbba.bba
//int key            put 0
//float t,			 put 0
//int frameLoc,		 put 3 if you encode all frames at once, 1 if you encode just first frame, 2 if you encode just last frame
//bool hasPTS = false 


void EncodeFromBufferIN(bool hasHeader,int automaticIN,int p_framesIN,int coding_typeIN,int p2q, int gs, void* bufferIN,int bufferINSize, unsigned char*  &bufferOUT,int &bufferOUTSize, int noFrames, bool saveINFile, int key, float t, int frameLoc, bool hasPTS = false );

#endif
