// OIKeySelectionFlag.h: interface for the OIKeySelectionFlag class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_KEYSELECTIONFLAG_H__6E006C06_8A0C_4CBD_9B7F_ACDF461036D1__INCLUDED_)
#define AFX_KEYSELECTIONFLAG_H__6E006C06_8A0C_4CBD_9B7F_ACDF461036D1__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "JWTemplArray.h"
#include "Entropy.h"
#include "SelectedKeyFrame.h"

class OIKeySelectionFlag  
{
public:
	OIKeySelectionFlag();
	virtual ~OIKeySelectionFlag();

public:
	void encodingProcess(CSelectedKeyFrame selectedKeyFrame);
	void InitializeModel();
	void makeBitstream(CAC_QF& codec, bool bPreserveKey);
	void encodeKeyFlag(CAC_QF& codec, int qstep, long int dQ);

public:
	int nNumOfKeyValue;
	JWArray<unsigned int> keyFlag;

	// model for arithmetic decoder
public:
	CAC keyFlagContext;
};

#endif // !defined(AFX_KEYSELECTIONFLAG_H__6E006C06_8A0C_4CBD_9B7F_ACDF461036D1__INCLUDED_)
